import { Type, DecoratorUtil, Store } from '@ucap/core';

import { AppConfiguration } from '../models/app-configuration';

export const STORE_KEY_APP_SETTINGS = '@ucap::electron::app::app-settings';

export function AppSettings(
  configuration: Partial<AppConfiguration> = {}
  // tslint:disable-next-line: ban-types
): Function {
  return <T>(target: Type<any>): TypedPropertyDescriptor<T> | void => {
    switch (DecoratorUtil.getDecoratorType([target])) {
      case 'class':
        Store.setBy(STORE_KEY_APP_SETTINGS, configuration)(target);
        break;
    }
  };
}

export function getAppSettings(
  target: Type<any>,
  configuration: Partial<AppConfiguration> = {}
): AppConfiguration {
  const store = Store.from(target).get(STORE_KEY_APP_SETTINGS) || {};

  return {
    ...store,
    ...configuration
  };
}
