import * as Electron from 'electron';

import { Type } from '@ucap/core';

import { AutoUpdaterConfiguration } from './models/auto-updater-configuration';

export abstract class Builder {
  static build<T>(
    autoUpdaterType: Type<T>,
    configuration: Partial<AutoUpdaterConfiguration>
  ): T {
    const autoUpdater = new autoUpdaterType(configuration);

    return autoUpdater;
  }
}
