import {
  BrowserWindowSettings,
  getBrowserWindowSettings
} from './decorators/browser-window-configuration';
import { On } from './decorators/on';

import { BrowserWindowConfiguration } from './models/browser-window-configuration';
import {
  EventHandlerConstructorOptions,
  EventHandlerMetadata
} from './models/event-handler.metadata';

import { EventHandlerRegistry } from './registries/event-handler.registry';

import { EventAttachType } from './types/event-attach.type';

import { Attacher } from './attacher';
import { Builder } from './builder';

import { ElectronBrowserWindow } from './electron-browser-window';

export {
  BrowserWindowSettings,
  getBrowserWindowSettings,
  On,
  BrowserWindowConfiguration,
  EventHandlerConstructorOptions,
  EventHandlerMetadata,
  EventHandlerRegistry,
  EventAttachType,
  Attacher,
  Builder,
  ElectronBrowserWindow
};
