import { DecoratorUtil } from '@ucap/core';

import { EventHandlerRegistry } from '../registries/event-handler.registry';
import { EventAttachType } from '../types/event-attach.type';

export function On(channel: string) {
  return <T>(
    target: any,
    targetKey?: string,
    descriptor?: TypedPropertyDescriptor<T>
  ): TypedPropertyDescriptor<T> | void => {
    switch (DecoratorUtil.getDecoratorType([target, targetKey, descriptor])) {
      case 'method':
        EventHandlerRegistry.use(
          target,
          targetKey!,
          EventAttachType.on,
          channel
        );

        return descriptor;
    }
  };
}
